using System.IO;
using System.Text;

static class Response {
    public static StringWriter Writer = new StringWriter();
    public static void WriteLine(object arg) {
        Writer.WriteLine(arg.ToString());
    }
    public static void Write(object arg) {
        Writer.Write(arg.ToString());
    }
    public static void Clear() { if (Writer != null) Writer.Dispose(); Writer = new StringWriter(); }
}

class Main {
    public static string Parse(string Input, TextWriter Errors) {
        string res = "";
        Response.Clear();
        try {
            using (MemoryStream Memo = new System.IO.MemoryStream(System.Text.Encoding.UTF8.GetBytes(Input))) {
                Scanner Scanner = new Scanner(Memo);
                Parser Parser = new Parser(Scanner);
                Parser.errors.errorStream = Errors;
                Parser.Parse();
                res = Response.Writer.ToString();
            }
        }
        catch (System.Exception ex) {
            res += ex.ToString();
        }
        return res;
    }
}